<?php

namespace App\Http\Controllers\Swagger\Responses\Bhua\Properties;

use OpenApi\Annotations\Schema;
use OpenApi\Annotations\Property;

/**
 * @Schema(
 *     title="品牌产品详情内容",
 *     description="品牌产品详情内容"
 * )
 */
class BhuaProductsDetailProperty
{
    /**
     * @Property(
     *     type="string",
     *     description="产品编号"
     * )
     *
     * @var string
     */
    public $code;

    /**
     * @Property(
     *     type="string",
     *     description="cas"
     * )
     *
     * @var string
     */
    public $cas;


    /**
     * @Property(
     *     type="string",
     *     description="中文名称"
     * )
     *
     * @var string
     */
    public $chemCnName;

    /**
     * @Property(
     *     type="string",
     *     description="英文名称"
     * )
     *
     * @var string
     */
    public $chemEnName;

    /**
     * @Property(
     *     type="string",
     *     description="中文名称"
     * )
     *
     * @var string
     */
    public $cnName;

    /**
     * @Property(
     *     type="string",
     *     description="英文名称"
     * )
     *
     * @var string
     */
    public $enName;

    /**
     * @Property(
     *     type="string",
     *     description="浓度等级"
     * )
     *
     * @var string
     */
    public $level;

    /**
     * @Property(
     *     type="string",
     *     description="货期"
     * )
     *
     * @var string
     */
    public $delivery;

    /**
     * @Property(
     *     type="number",
     *     description="单价"
     * )
     *
     * @var string
     */
    public $price;

    /**
     * @Property(
     *     type="integer",
     *     description="状态"
     * )
     *
     * @var string
     */
    public $status;

    /**
     * @Property(
     *     type="string",
     *     description="包装规格"
     * )
     *
     * @var string
     */
    public $pack;

}
