<?php

namespace App\Repositories\Criteria;

use Illuminate\Database\Eloquent\Builder;
use App\Repositories\Criteria\Criteria; 

class BaseCriteria extends Criteria
{
    protected function condition(Builder $query): void
    {
        if ($this->request->has('created_at')) {
            $createdAt = $this->request->offsetGet('created_at');
            if(!empty($createdAt)){
                list($start,$end) = explode(',',$createdAt);

                if(!preg_match('/[0-9]{4}\-[0-9]{2}\-[0-9]{2}\ [0-9]{2}\:[0-9]{2}\:[0-9]{2}/i',$start)){
                    $start = $start. ' 00:00:00';
                }
                if(!preg_match('/[0-9]{4}\-[0-9]{2}\-[0-9]{2}\ [0-9]{2}\:[0-9]{2}\:[0-9]{2}/i',$end)){
                    $end = $end. ' 23:59:59';
                }

                if(!empty($start) && !empty($end)){
                    $query->whereRaw('created_at >= "'.$start.'" and created_at < "'.$end.'"');
                }
            }
        }

        if ($this->request->has('createdAt')) {
            $createdAt = $this->request->offsetGet('createdAt');
            if(!empty($createdAt)){
                list($start,$end) = explode(',',$createdAt);

                if(!preg_match('/[0-9]{4}\-[0-9]{2}\-[0-9]{2}\ [0-9]{2}\:[0-9]{2}\:[0-9]{2}/i',$start)){
                    $start = $start. ' 00:00:00';
                }
                if(!preg_match('/[0-9]{4}\-[0-9]{2}\-[0-9]{2}\ [0-9]{2}\:[0-9]{2}\:[0-9]{2}/i',$end)){
                    $end = $end. ' 23:59:59';
                }

                if(!empty($start) && !empty($end)){
                    $query->whereRaw('created_at >= "'.$start.'" and created_at < "'.$end.'"');
                }
            }
        }
    }
}
