<?php

namespace App\Repositories\Eloquent;


use App\Repositories\Contracts\FileManageRepository;
use App\Repositories\Models\FileManage;
use Prettus\Validator\Contracts\ValidatorInterface;
use App\Repositories\BaseRepository;

class FileManageRepositoryEloquent extends BaseRepository implements FileManageRepository
{

    /**
     * 定义validator的检索规则
     * @var \string[][]
     */
    public $rules = [
        ValidatorInterface::RULE_CREATE => [
            'uniqueid' => 'required|string',
            'name' => 'required|string',
            'type' => 'required|string',
            'extension' => 'required|string',
            'path'  => 'required|string',
            'mime_type' => 'required|string',
            'byte_size' => 'required',
        ],
    ];

    /**
     * Specify Model class name.
     *
     * @return string
     */
    public function model()
    {
        return FileManage::class;
    }

    public function saveUplodFiles($fileImage)
    {
        $saveParams = $fileImage;

        if($file = $this->getFileByUniqueId($saveParams['uniqueid'])){
            $saveParams['updated_at'] = date('Y-m-d H:i:s',time());
            $file = $file->update($saveParams);
        }else{
            $saveParams['type'] = (isset($saveParams['type']) && !empty($saveParams['type'])) ? $saveParams['type'] : 'image';
            $saveParams['created_at'] = date('Y-m-d H:i:s',time());
            $file = $this->create($saveParams);
        }
        return $file;
    }

    public function getFileByUniqueId($id)
    {
        $file = $this->findWhere(['uniqueid' => $id]);
        return $file->first();
    }

}
