<?php

namespace App\Rhawn\Repositories\Eloquent\Chemsite;

use App\Rhawn\Repositories\Contracts\Chemsite\ChemsiteCompanyRepository;
use App\Rhawn\Repositories\Eloquent\BaseRepository;
use App\Rhawn\Repositories\Models\Chemsite\ChemsiteCompany;
use Illuminate\Support\Facades\DB;

/**
 * Class UserRepositoryEloquent.
 */
class ChemsiteCompanyRepositoryEloquent extends BaseRepository implements ChemsiteCompanyRepository
{
    /**
     * Specify Model class name.
     *
     * @return string
     */
    public function model(): string
    {
        return ChemsiteCompany::class;
    }

    public function getCompanyThroughCusCode($cusCode)
    {
        return $this->findWhere(['com_cus_no' => $cusCode])->first();
    }

    public function getCompanyList($where,$offset,$limit)
    {
        $customerModel = DB::connection($this->getConnectionName())->table($this->getTableName());
        if(!empty($where)){
            $customerModel = $customerModel->where($where);
        }
        $customerInfo = $customerModel->offset($offset)
            ->limit($limit)
            ->get();

        if($customerInfo){
            return $customerInfo->toArray();
        }
        return null;
    }
}
