<?php

namespace App\Rhawn\Services\Chemsite;

use App\Rhawn\Repositories\Contracts\Chemsite\ChemsiteCompanyRepository;

class ChemsiteCompanyService
{
    private ChemsiteCompanyRepository $chemsiteCompanyRepository;

    public function __construct(ChemsiteCompanyRepository $chemsiteCompanyRepository)
    {
        $this->chemsiteCompanyRepository = $chemsiteCompanyRepository;
    }

    public function getCompanyThroughCusCode($cusCode)
    {
        $company = $this->chemsiteCompanyRepository->getCompanyThroughCusCode($cusCode);
        if($company){
            $company = $company->toArray();
            $company['cus_id'] = $company['com_id'];
            $company['cus_no'] = $company['com_cus_no'];
            $company['cus_company'] = $company['com_name'];
            return $company;
        }
        return null;
    }

    public function getCustomerListByCusCode($cusNo,$offset,$limit)
    {
        $company = $this->chemsiteCompanyRepository->getCompanyList(['com_cus_no' => $cusNo],$offset,$limit);
        if($company){
            $company = $company->toArray();
            foreach($company as &$c){
                $c['cus_id'] = $c['com_id'];
                $c['cus_no'] = $c['com_cus_no'];
                $c['cus_company'] = $c['com_name'];
            }
            return $company;
        }
        return null;
    }
}
