<?php

namespace App\Rhawn\Services\Chemsite;

use App\Rhawn\Repositories\Contracts\Chemsite\ChemsiteCustomerRepository;

class ChemsiteCustomerService
{
    private ChemsiteCustomerRepository $customerRepository;

    public function __construct(ChemsiteCustomerRepository $chemsiteCustomerRepository)
    {
        $this->chemsiteCustomerRepository = $chemsiteCustomerRepository;
    }

    public function getCustomerThroughCusCode($cusCode)
    {
        $customer = $this->chemsiteCustomerRepository->getCustomerThroughCusCode($cusCode);
        return $customer->toArray();
    }

    public function checkCustomerExist($cusCode)
    {
        //查询用户是否存在
        $customer = $this->chemsiteCustomerRepository->getCustomerThroughCusCode($cusCode);
        if(!$customer){
            throw new \Exception('客户编号为:['.$cusCode.']的用户不存在!',500);
        }
        return $customer;
    }
}
