<?php

namespace App\Services\Api;

use App\Services\FileService;
use App\Services\Traits\Pdf\BasePdfTemplate;
use Illuminate\Support\Facades\Storage;

class ChemicalsMsdsService
{
    use BasePdfTemplate;

    public function getMsds($cas, $type = null, $comInfo = null)
    {
        $fileService = app(FileService::class);
        $msdPdf = $fileService->getFileListByModelData($comInfo['cus_type'].'_'.$cas.'_msds', $comInfo['cus_number']);
        if($msdPdf){
           return $fileService->getDownloadUrl(current($msdPdf)['uniqueid']);
        }

        /*$findResult = shell_exec('find '.env('MSDS_FILE_DIR').' -iname \''.$cas.'\' -print');
        if(is_null($findResult)){
            return null;
        }*/

        $msds_html = file_get_contents(env('MSDS_FILE_DIR').'/'.$cas.'/'.$cas.'_sds_'.$type.'.html');
        if($msds_html){
            if(!is_null($comInfo)){
                $platformParams = json_decode($comInfo['platform_params'], true);
                $msds_html = preg_replace('/<dt>企业名称：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业名称：</dt> <dd>'.$platformParams['company_name'].'</dd>', $msds_html);
                $msds_html = preg_replace('/<dt>企业地址：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>企业地址：</dt> <dd>'.$platformParams['company_address'].'</dd>', $msds_html);
                $msds_html = preg_replace('/<dt>传真：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>传真：</dt> <dd>'.$platformParams['company_fax'].'</dd>', $msds_html);
                $msds_html = preg_replace('/<dt>联系电话：<\/dt>[\s\S]*?<dd>[\s\S]*?<\/dd>/i', '<dt>联系电话：</dt> <dd>'.$platformParams['company_phone'].'</dd>', $msds_html);
            }


            $msds_html = preg_replace('/<html>/i', '<html lang="zh_CN no-js">', $msds_html);
            $msds_html = preg_replace('/<meta[\s]*?charset=[\"]UTF\-8[\"]/i', '<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
            <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no">', $msds_html);

            preg_match('/<body>[\s]*?<style>(?<bodyStyle>[\s\S]*?)<\/style>/i',$msds_html, $bodyStyle);

            $msds_html = preg_replace('/<body>[\s]*?<style>(?<bodyStyle>[\s\S]*?)<\/style>/i', '@body@', $msds_html);
            $bodyStyle['bodyStyle'] = "<style>body{  font-family: 'msyh'; font-size: 0.8rem; font-weight: bold; display: block;}.container { padding-right: 5px;padding-left: 5px;margin-right: auto;margin-left: auto;width: 90%;} " .
                $bodyStyle['bodyStyle']."</style><body><div class='container'>";

            // 格式化处理
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?\{[\s]*?line-height: 1.5;[\s]*?\}/i', '.sds-cn{line-height: 2.5;}', $bodyStyle['bodyStyle']);
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?dd.clearfix[\s]*?\{ margin-left: 20px;[\s]*?\}/i', '.sds-cn dd.clearfix { width:80% }', $bodyStyle['bodyStyle']);
            $bodyStyle['bodyStyle'] = preg_replace('/\.sds-cn[\s]*?\.list-line[\s]*?li:before[\s]*?\{ content: " —— " \}/i', '.sds-cn .list-line li:before { content: " -- " }', $bodyStyle['bodyStyle']);

            //$msds_html = preg_replace('/11123/', $bodyStyle['bodyStyle'], $msds_html);
            $msds_html = preg_replace('/<\/body>/', '</div></body>', preg_replace('/@body@/', $bodyStyle['bodyStyle'], $msds_html));

            //file_put_contents('./test.html', $msds_html);

            $this->getPdfApp()->loadHTML($msds_html, 'utf-8');
            //echo $htmlTemp;
            $this->getPdfApp()->render();
            $pdf = $this->getPdfApp()->output();

            if($pdf){
                $fileName = $cas.'/'.$comInfo['cus_number'].'_'.$cas.'_'.$comInfo['cus_type'].'_msds.pdf';
                $realPath = $fileService->getFileFolderPath().'/'.$fileName;
                if($fileService->saveToFile($realPath, $pdf)){
                    $fileSave = [];
                    $fileSave['uniqueid'] = $fileService->getBase64Path($realPath);
                    $fileSave['type'] = 'file';
                    $fileSave['path'] = $realPath;
                    $fileSave['name'] = str_replace('.pdf','',$fileName);
                    $fileSave['extension'] = 'pdf';
                    $fileSave['mime_type'] = 'application/pdf';
                    $fileSave['byte_size'] = '';
                    $fileSave['model_name'] = $comInfo['cus_type'].'_'.$cas.'_msds';
                    $fileSave['model_data_id'] = $comInfo['cus_number'];
                    if($fileService->saveFileRecord($fileSave)){
                        return $fileService->getDownloadUrl($fileSave['uniqueid']);
                    }
                }
            }
        }

        return null;
    }
}
