<?php

/*
 * This file is part of the Jiannei/lumen-api-starter.
 *
 * (c) Jiannei <longjian.huang@foxmail.com>
 *
 * This source file is subject to the MIT license that is bundled
 * with this source code in the file LICENSE.
 */

namespace App\Services;

use App\Repositories\Contracts\EmailSendLogsRepository;
use App\Services\Traits\BaseService;
use App\Support\Traits\Helpers;

class EmailSendLogsService
{
    use Helpers, BaseService;

    public function __construct(EmailSendLogsRepository $emailSendLogsRepository)
    {
        $this->setRepository($emailSendLogsRepository);
    }

    public function saveEmailLogs($platformName, $platformType, $cusInfo, $message, $sendType = 'invoiceEmail')
    {
        $saveParams = [];
        $saveParams['send_platform_name'] = $platformName;
        $saveParams['send_platform_type'] = $platformType;
        $saveParams['send_type'] = $sendType;
        $saveParams['cus_name'] = $cusInfo['cus_name'];
        $saveParams['cus_email'] = $cusInfo['cus_invoice_email'];
        $saveParams['send_content'] = $message;

        return $this->getRepository()->createOrUpdate($saveParams);
    }
}
