<?php

namespace App\Services\ThirdPlatform;

use App\Repositories\Contracts\ThirdApiPlatformRepository;
use App\Services\ThirdPlatform\Api\CheMenuApiService;
use App\Support\Facades\SimpleLogs;
use App\Support\Traits\Helpers;

class CheMenuService
{
    use Helpers;

    public function __construct()
    {
        $this->apiService = (new CheMenuApiService(app(ThirdApiPlatformRepository::class)));
    }

    public function allCategory()
    {
        $responseHtml = $this->apiService->getAllCatetgory();
        if($responseHtml){
            $categoryDivRegx = '/<dt><span[\s]*?style=[\\\'|\"][\s\S]+?[\\\'|\"]>(?<categoryH1>[\s\S]+?)<\/span>[\s\S]*?<dd>(?<category>[\s\S]+?)<\/dd>/i';
            preg_match_all($categoryDivRegx, $responseHtml,$categoryHtml);
            if($categoryHtml){
                foreach($categoryHtml['categoryH1'] as $key => $h1){
                    if(!empty($categoryHtml['category'][$key])){
                        preg_match_all('/<a[\s]*?href=[\\\'|\"](?<href>[\s\S]+?)[\\\'|\"]>(?<categoryName>[\s\S]+?)<\/a>/i', $categoryHtml['category'][$key],$categoryList);
                        if(!empty($categoryList)){
                            foreach($categoryList['categoryName'] as $k => $category){
                                $this->apiService->saveCategory($category, $h1, $categoryList['href'][$k]);
                                $jobContent = [
                                    'params' => ['url' => $categoryList['href'][$k]],
                                    'consumer' => __CLASS__,
                                    'method' => 'categoryPage'
                                ];
                                $this->apiService->pushQueue($jobContent,'chemenu_category_page');
                            }
                        }
                    }
                    sleep(60);
                }
            }

            return true;
        }
    }

    public function updateAllCategoryDesc()
    {
        $responseHtml = $this->apiService->getAllCatetgory();
        if($responseHtml){
            $categoryDivRegx = '/<dt><span[\s]*?style=[\\\'|\"][\s\S]+?[\\\'|\"]>(?<categoryH1>[\s\S]+?)<\/span>[\s\S]*?<dd>(?<category>[\s\S]+?)<\/dd>/i';
            preg_match_all($categoryDivRegx, $responseHtml,$categoryHtml);
            if($categoryHtml){
                foreach($categoryHtml['categoryH1'] as $key => $h1){
                    if(!empty($categoryHtml['category'][$key])){
                        preg_match_all('/<a[\s]*?href=[\\\'|\"](?<href>[\s\S]+?)[\\\'|\"]>(?<categoryName>[\s\S]+?)<\/a>/i', $categoryHtml['category'][$key],$categoryList);
                        if(!empty($categoryList)){
                            foreach($categoryList['categoryName'] as $k => $category){
                                $pageUrl = $categoryList['href'][$k];
                                $responseHtml = $this->apiService->getPage($pageUrl);
                                if($responseHtml){
                                    if(preg_match('/<span[\s]*?class=[\\\'|\"]caption-subject font-blue-sharp bold[\\\'|\"]>Sorry ! You visit too frequently, please complete validation[\s\S]*?<\/span><\/h2>/i', $responseHtml)){
                                        SimpleLogs::writeLog('遇到反爬系统', 'chemenu info', 'info');
                                        $jobContent = [
                                            'params' => ['url' => $pageUrl],
                                            'consumer' => __CLASS__,
                                            'method' => 'categoryPage'
                                        ];
                                        $this->apiService->pushQueue($jobContent,'chemenu_category_page');
                                        break;
                                    }
                                    SimpleLogs::writeLog('开始分析分类页面数据', 'chemenu info', 'info');
                                    $titleDivRegx = '/<div[\s]*?class=[\\\'|\"]cate_desc[\\\'|\"]>[\S\s]*<h2[\s]*?class=[\\\'|\"]desc_title[\\\'|\"]>(?<title>[\s\S]+?)<\/h2>[\s\S]*?<p[\s]*?class=[\\\'|\"]desc_content[\\\'|\"]>(?<content>[\s\S]*?)<\/p>/i';
                                    preg_match($titleDivRegx, $responseHtml,$titleHtml);
                                    if($titleHtml){
                                        $this->apiService->updateCategoryDesc($category, $titleHtml['content']);
                                    }
                                }
                            }
                        }
                    }
                    sleep(60);
                }
            }

            return true;
        }
    }

    public function categoryPage($url)
    {
        try{
            $pageUrl = $url['url'];
            SimpleLogs::writeLog('开始抓取'.$pageUrl.'分类页面数据', 'chemenu info', 'info');
            $pageIndex = 1;
            while(true){
                $responseHtml = $this->apiService->getPage($pageUrl);
                //file_put_contents('./test2.txt', $responseHtml);
                if($responseHtml){
                    if(preg_match('/<span[\s]*?class=[\\\'|\"]caption-subject font-blue-sharp bold[\\\'|\"]>Sorry ! You visit too frequently, please complete validation[\s\S]*?<\/span><\/h2>/i', $responseHtml)){
                        SimpleLogs::writeLog('遇到反爬系统', 'chemenu info', 'info');
                        $jobContent = [
                            'params' => ['url' => $pageUrl],
                            'consumer' => __CLASS__,
                            'method' => 'categoryPage'
                        ];
                        $this->apiService->pushQueue($jobContent,'chemenu_category_page');
                        break;
                    }
                    SimpleLogs::writeLog('开始分析分类页面数据', 'chemenu info', 'info');
                    $titleDivRegx = '/<div[\s]*?class=[\\\'|\"]cate_desc[\\\'|\"]>[\S\s]*<h2[\s]*?class=[\\\'|\"]desc_title[\\\'|\"]>(?<title>[\s\S]+?)<\/h2>[\s\S]*?<p[\s]*?class=[\\\'|\"]desc_content[\\\'|\"]>(?<content>[\s\S]*?)<\/p>/i';
                    preg_match($titleDivRegx, $responseHtml,$titleHtml);

                    $productDivRegx = '/<div[\s]*?class=[\\\'|\"]col-lg-3 col-sm-6 col-md-4 col-xs-6 products_rows_div[\\\'|\"]>[\S\s]*?<div[\s]*?class=[\\\'|\"]cas_img[\\\'|\"]>[\s]*?<a[\s]*href=[\\\'|\"](?<href>[\S\s]+?)[\\\'|\"][\s\S]*?>[\s\S]+?<\/div>/i';
                    preg_match_all($productDivRegx, $responseHtml, $productList);
                    if($productList){
                        foreach($productList['href'] as $href){
                            $productJobContent = [
                                'params' => ['url' => $href],
                                'consumer' => __CLASS__,
                                'method' => 'productPage'
                            ];
                            $this->apiService->pushQueue($productJobContent,'chemenu_product_page');
                        }

                        //分页处理
                        if(preg_match('/<nav[\s]*?class=[\\\'|\"]paging[\\\'|\"]>/i', $responseHtml)){
                            if(preg_match('/<li[\s]*?id=[\\\'|\"]pagination_next[\\\'|\"][\s]*?class=[\\\'|\"]disabled[\\\'|\"]>/i', $responseHtml)){
                                break;
                            }
                            if(preg_match('/<li[\s]*?id=[\\\'|\"]pagination_next[\\\'|\"]>[\s]*?<a[\S\s]*?href=[\\\'|\"](?<nextHref>[\s\S]+?)[\\\'|\"]/i', $responseHtml, $nextHref)){
                                $pageUrl = str_replace($this->apiService->getDomain(), '', $nextHref['nextHref']);

                                SimpleLogs::writeLog('开始下一页抓取,链接：'.$pageUrl, 'chemenu info', 'info');
                            }else{
                                SimpleLogs::writeLog('分类页面抓取结束', 'chemenu info', 'info');
                                break;
                            }
                            if($pageIndex == 8){
                                $jobContent = [
                                    'params' => ['url' => $pageUrl],
                                    'consumer' => __CLASS__,
                                    'method' => 'categoryPage'
                                ];
                                $this->apiService->pushQueue($jobContent,'chemenu_category_page');
                                $pageIndex = 1;
                                break;
                            }
                            $pageIndex ++;

                            $randomFloat = 3 + mt_rand(0, 3) + (mt_rand(0, 999) / 1000);
                            usleep($randomFloat * 1000000); // 微秒级延迟
                        }
                    }
                }
            }
        }catch(\Throwable $exception){
            SimpleLogs::writeLog($exception->getMessage(), 'chemenu error', 'error');
        }
    }


    public function productPage($url)
    {
        try{
            $pageUrl = $url['url'];
            SimpleLogs::writeLog('开始抓取'.$pageUrl.'页面数据', 'chemenu info', 'info');
            $randomFloat = 2 + mt_rand(0, 2) + (mt_rand(0, 999) / 1000);
            usleep($randomFloat * 1000000); // 微秒级延迟

            $responseHtml = $this->apiService->getPage($pageUrl);
            //file_put_contents('./test3.html', $responseHtml);
            if($responseHtml){
                if(preg_match('/<span[\s]*?class=[\\\'|\"]caption-subject font-blue-sharp bold[\\\'|\"]>Sorry ! You visit too frequently, please complete validation[\s\S]*?<\/span><\/h2>/i', $responseHtml)){
                    SimpleLogs::writeLog('遇到反爬系统', 'chemenu info', 'info');
                    $productJobContent = [
                        'params' => ['url' => $pageUrl],
                        'consumer' => __CLASS__,
                        'method' => 'productPage'
                    ];
                    $this->apiService->pushQueue($productJobContent,'chemenu_product_page');

                    $cmd = 'sh /var/www/openapi/server/script/restartAdsl.sh';
                    trim(shell_exec("$cmd 2>&1"));

                    return true;
                }
                $productPageContent = [];
                SimpleLogs::writeLog('页面基础数据获取成功', 'chemenu info', 'info');

                //分类
                $productPageContent['categoryName'] = '';
                if(preg_match('/<li>[\s\S]*Category:[\s]*?(?<categoryList>[\s\S]*?)<\/li>/i', $responseHtml, $navBar)){
                    if(preg_match_all('/<a[\s\S]*?>(?<categoryName>[\s\S]*?)<\/a>/i', $navBar['categoryList'], $navCategorys)){
                        $categoryList = [];
                        foreach($navCategorys['categoryName'] as $categoryName){
                            $categoryList[] = $categoryName;
                        }
                        $productPageContent['categoryName'] = implode(',', $categoryList);
                    }
                }

                $productPageContent['image'] = '';
                if(preg_match('/<div[\s]*?class=[\\\'|\"]products-content[\\\'|\"]>/i', $responseHtml)){
                    $imageDivRegx = '/<div[\s]*?class=[\\\'|\"]product-image[\\\'|\"]>[\s\S]*?<img[\s]*?class=[\\\'|\"]big_img[\\\'|\"][\s]*?src[\s\S]*?[\\\'|\"](?<image>[\s\S]+?)[\\\'|\"]/i';
                    preg_match($imageDivRegx, $responseHtml, $image);
                    if($image && $image['image']){
                        $productPageContent['image'] = $image['image'];
                    }

                    $productNameDivRegx = '/<div[\s]*?class=[\\\'|\"]col-md-12 col-sm-12[\\\'|\"]>[\s]*?<p[\s]*?class=[\\\'|\"]padding-tb-15[\\\'|\"]>[\s]*?<b>(?<name>[\s\S]+?)<\/b>(?<nameContent>[\s\S]+?)<\/p>/i';
                    preg_match_all($productNameDivRegx, $responseHtml, $productName);
                    if($productName){
                        foreach($productName['nameContent'] as $key => $name){
                            $strName = $this->stripHtml($name);
                            if(substr($strName, 0, 1) == ':'){
                                $strName = str_replace(':', '', $strName);
                                switch($key){
                                    case 0:
                                        $productPageContent['productName'] = $strName;break;
                                    case 1:
                                        $productPageContent['IUPAC'] = $strName;break;
                                }
                            }
                        }
                    }

                    $productPageContent['casInfo'] = [];
                    $chemicalInfoDivRegx = '/<div[\s]*?class=[\\\'|\"]col-md-6 col-sm-12[\\\'|\"]>(?<chemicalInfoDiv>[\s\S]+?)<\/div>/i';
                    preg_match_all($chemicalInfoDivRegx, $responseHtml, $chemicalInfoDiv);
                    if($chemicalInfoDiv){
                        foreach($chemicalInfoDiv['chemicalInfoDiv'] as $div){
                            $div = $this->stripHtml($div);
                            $infoList = explode("\r\n",$div);
                            foreach($infoList as $info){
                                $info = trim($info);
                                if(empty($info)) continue;
                                try{
                                    list($name, $content) = explode('：', $info);
                                }catch(\Throwable $exception){
                                    list($name, $content) = explode(':', $info);
                                }
                                $productPageContent['casInfo'][$name] = $content;
                            }
                        }
                    }
                    //$productPageContent['casInfo'] = array_unique($productPageContent['casInfo'],SORT_REGULAR);

                    $productListDivRegx = '/<div[\s]*?class=[\\\'|\"]col-md-12 col-lg-12 col-sm-12 product-details-size[\\\'|\"]>[\s\S]*?<tbody>(?<productList>[\s\S]*?)<\/tbody>/i';
                    if(preg_match_all($productListDivRegx, $responseHtml, $productList)){
                        if(!empty($productList['productList'])){
                            foreach($productList['productList'] as $product){
                                $product = $this->stripTabTag($product);
                                preg_match_all('/<td[\s\S]*?>(?<content>[\s\S]*?)<\/td>/i', $product, $productContentTd);
                                $productPageContent['productList'] = [];
                                if($productContentTd['content']){
                                    $productContent = $productContentTd['content'];
                                    $productContent = array_chunk($productContent, 5);
                                    foreach($productContent as $content){
                                        if(empty($content[0])) continue;
                                        $productPageContent['productList'][] = ['productUnit' => $content[0], 'stock' => $content[1]];
                                    }
                                }
                            }
                        }
                    }
                    SimpleLogs::writeLog('数据解析结束。数据：'.json_encode($productPageContent, JSON_UNESCAPED_UNICODE), 'chemenu info', 'info');
                    //$randomFloat = 2 + mt_rand(0, 2) + (mt_rand(0, 999) / 1000);
                    //usleep($randomFloat * 1000000); // 微秒级延迟

                    $this->apiService->saveProduct($productPageContent);
                }
                $randomFloat = 5 + mt_rand(0, 5) + (mt_rand(0, 999) / 1000);
                usleep($randomFloat * 1000000); // 微秒级延迟
            }
        }catch(\Throwable $exception){
            SimpleLogs::writeLog($exception->getMessage(), 'chemenu error', 'error');
            if(!empty($productPageContent)){
                $productJobContent = [
                    'params' => ['content' => $productPageContent],
                    'consumer' => __CLASS__,
                    'method' => 'productSave'
                ];
                $this->apiService->pushQueue($productJobContent,'chemenu_product_save');
            }else{
                $productJobContent = [
                    'params' => ['url' => $pageUrl],
                    'consumer' => __CLASS__,
                    'method' => 'productPage'
                ];
                $this->apiService->pushQueue($productJobContent,'chemenu_product_page');;
            }
        }
    }

    public function productSave($productPageContent)
    {
        if(!$productPageContent || !$productPageContent['content']) return false;

        try{
            SimpleLogs::writeLog('数据保存开始。数据：'.json_encode($productPageContent['content'], JSON_UNESCAPED_UNICODE), 'chemenu info', 'info');
            $this->apiService->saveProduct($productPageContent['content']);
        }catch(\Throwable $exception){
            $productJobContent = [
                'params' => ['content' => $productPageContent['content']],
                'consumer' => __CLASS__,
                'method' => 'productSave'
            ];
            $this->apiService->pushQueue($productJobContent,'chemenu_product_save');
        }
    }
}
