<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateFileManageTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('file_manage', function (Blueprint $table) {
            $table->id();

            $table->longText('uniqueid')->comment('uniqueid')->nullable(false);
            $table->string('name')->comment('文件名称')->nullable(false);
            $table->string('extension')->comment('扩展名')->nullable(false);
            $table->string('type')->comment('图片类型')->nullable(false)->default('image');
            $table->text('path')->nullable(false)->comment('保存路径');
            $table->string('mime_type')->nullable(false)->comment('mime类型');
            $table->integer('byte_size')->nullable(false)->comment('文件大小');
            $table->string('model_name')->nullable()->comment('模型名称');

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('file_manage');
    }
}
